| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
ToolHandle< T > Class Template Reference

Handle to be used in lieu of naked pointers to tools. More...

`#include <GaudiKernel/ToolHandle.h>`

Inheritance diagram for ToolHandle< T >:
[legend]
Collaboration diagram for ToolHandle< T >:
[legend]

## Public Member Functions
| ToolHandle (const IInterface *parent=nullptr, bool createIf=true)
| Constructor for a tool with default tool type and name. More...
| ToolHandle (const std::string &toolTypeAndName, const IInterface *parent=nullptr, bool createIf=true)
| Create a handle ('smart pointer') to a tool. More...
StatusCode | initialize (const std::string &toolTypeAndName, const IInterface *parent=nullptr, bool createIf=true)
StatusCode | retrieve () const
| Retrieve the AlgTool. More...
StatusCode | release () const
| Release the AlgTool. More...
StatusCode | retrieve (T *&algTool) const override
| Do the real retrieval of the AlgTool. More...
StatusCode | release (T *algTool) const override
| Do the real release of the AlgTool. More...
IAlgTool * | get () const override
std::string | typeAndName () const override
Public Member Functions inherited from BaseToolHandle
virtual | ~BaseToolHandle ()
StatusCode | retrieve (IAlgTool *&tool) const
Public Member Functions inherited from ToolHandleInfo
virtual | ~ToolHandleInfo ()=default
bool | isPublic () const
bool | createIf () const
const IInterface * | parent () const
Public Member Functions inherited from GaudiHandle< T >
| GaudiHandle (const GaudiHandle &other)
| Copy constructor needed for correct ref-counting. More...
GaudiHandle & | operator= (const GaudiHandle &other)
| Assignment operator for correct ref-counting. More...
| ~GaudiHandle ()
StatusCode | retrieve () const
| Retrieve the component. More...
StatusCode | release () const
| Release the component. More...
bool | isValid () const
| Check if the handle is valid (try to retrive the object is not done yet). More...
| operator bool () const
| For testing if handle has component. More...
T * | get () const
| Return the wrapped pointer, not calling retrieve() if null. More...
bool | isSet () const
| True if the wrapped pointer is not null. More...
T & | operator* ()
T * | operator-> ()
T & | operator* () const
T * | operator-> () const
std::string | getDefaultType ()
| Helper function to get default type string from the class type. More...
std::string | getDefaultName ()
Public Member Functions inherited from GaudiHandleBase
std::string | typeAndName () const
| The full type and name: "type/name". More...
std::string | type () const
| The concrete component class name: the part before the '/'. More...
std::string | name () const
| The instance name: the part after the '/'. More...
bool | empty () const
| Check if the handle has been set to empty string (i.e. More...
void | setTypeAndName (std::string myTypeAndName)
| The component "type/name" string. More...
void | setName (const std::string &myName)
| Set the instance name (part after the '/') without changing the class type. More...
std::string | pythonPropertyClassName () const
| Name of the componentType with "Handle" appended. More...
std::string | messageName () const
| name used for printing messages More...
virtual std::string | pythonRepr () const
| Python representation of handle, i.e. More...
Public Member Functions inherited from GaudiHandleInfo
virtual | ~GaudiHandleInfo ()=default
| virtual destructor so that derived class destructor is called. More...
const std::string & | componentType () const
const std::string & | propertyName () const
| name as used in declareProperty(name,gaudiHandle) More...
void | setPropertyName (std::string propName)
| set name as used in declareProperty(name,gaudiHandle). More...
const std::string & | parentName () const
| The name of the parent. More...

## Protected Member Functions
StatusCode | i_retrieve (IAlgTool *&algTool) const override
Protected Member Functions inherited from BaseToolHandle
| BaseToolHandle (const IInterface *parent=nullptr, bool createIf=true)
Protected Member Functions inherited from ToolHandleInfo
| ToolHandleInfo (const IInterface *parent=nullptr, bool createIf=true)
Protected Member Functions inherited from GaudiHandle< T >
| GaudiHandle (std::string myTypeAndName, std::string myComponentType, std::string myParentName)
Protected Member Functions inherited from GaudiHandleBase
| GaudiHandleBase (std::string myTypeAndName, std::string myComponentType, std::string myParentName)
| Create a handle ('smart pointer') to a gaudi component. More...
Protected Member Functions inherited from GaudiHandleInfo
| GaudiHandleInfo (std::string myComponentType, std::string myParentName)
| Some basic information and helper functions shared between various handles/arrays. More...
void | setComponentType (const std::string &componentType)
| The component type. More...
void | setParentName (const std::string &parent)
| The name of the parent. More...

## Private Attributes
ServiceHandle< IToolSvc > | m_pToolSvc

## Friends
class | Algorithm
class | AlgTool
class | Service

## Additional Inherited Members
Static Public Member Functions inherited from ToolHandleInfo
static std::string | toolComponentType (const IInterface *parent)
static std::string | toolParentName (const IInterface *parent)
Protected Attributes inherited from ToolHandleInfo
const IInterface * | m_parent
bool | m_createIf

## Detailed Description

### template<class T>
class ToolHandle< T >

Handle to be used in lieu of naked pointers to tools.

This allows better control through the framework of tool loading and usage. T is the AlgTool interface class (or concrete class) of the tool to use, and must derive from IAlgTool.

Author
  Wim Lavrijsen WLavr.nosp@m.ijse.nosp@m.n@lbl.nosp@m..gov
  Marti.nosp@m.n.Wo.nosp@m.udstr.nosp@m.a@ce.nosp@m.rn.ch

Definition at line 22 of file PropertyMgr.h.

## Constructor & Destructor Documentation

template<class T>

ToolHandle< T >::ToolHandle | ( | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Constructor for a tool with default tool type and name.

Can be called only if the type T is a concrete tool type (not an interface), and you want to use the default name.

Definition at line 107 of file ToolHandle.h.

108 : BaseToolHandle(parent,createIf),
109 GaudiHandle<T>( GaudiHandle<T>::getDefaultType(),
110 toolComponentType(parent),
111 toolParentName(parent) ),
112 m_pToolSvc( "ToolSvc", GaudiHandleBase::parentName() )
113 { }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:171
GaudiHandle::getDefaultType
std::string getDefaultType()
Helper function to get default type string from the class type.
Definition: GaudiHandle.h:266
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:214
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:47
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:49
BaseToolHandle::BaseToolHandle
BaseToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Definition: ToolHandle.h:69
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:43
ToolHandleInfo::createIf
bool createIf() const
Definition: ToolHandle.h:36
template<class T>

ToolHandle< T >::ToolHandle | ( | const std::string & | toolTypeAndName,
|  | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Create a handle ('smart pointer') to a tool.

The arguments are passed on to ToolSvc, and have the same meaning:

StatusCode ToolSvc::retrieveTool ( const std::string& type ,
T*& tool ,
const IInterface* parent = 0 ,
bool createIf = true )

Parameters

  owner | class owning the ToolHandle
  toolType | "MyToolType/MyToolName" "MyToolType" is short for "MyToolType/MyToolType" 'MyToolType' is the name of the class of the concrete tool 'MyToolName' is to distinguish several tool instances of the same class
  parent | the parent Algorithm,Tool or Service of which this tool is a member. If non-zero, the the tool is a private tool of the parent, otherwise it is a public (shared) tool.
  createIf | if true, create tool if not yet existing.

Definition at line 146 of file ToolHandle.h.

148 : BaseToolHandle(parent,createIf),
149 GaudiHandle<T>( toolTypeAndName,
150 toolComponentType(parent),
151 toolParentName(parent) ),
152 m_pToolSvc( "ToolSvc", GaudiHandleBase::parentName() )
153 { }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:171
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:214
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:47
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:49
BaseToolHandle::BaseToolHandle
BaseToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Definition: ToolHandle.h:69
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:43
ToolHandleInfo::createIf
bool createIf() const
Definition: ToolHandle.h:36

## Member Function Documentation

template<class T>

IAlgTool* ToolHandle< T >::get | ( |  | ) | const
| inline override virtual

Implements BaseToolHandle.

Definition at line 196 of file ToolHandle.h.

196 {
197 return GaudiHandle<T>::get();
198 }
GaudiHandle::get
T * get() const
Return the wrapped pointer, not calling retrieve() if null.
Definition: GaudiHandle.h:236
template<class T>

StatusCode ToolHandle< T >::i_retrieve | ( | IAlgTool *& | algTool | ) | const
| inline override protected virtual

Implements BaseToolHandle.

Definition at line 204 of file ToolHandle.h.

204 {
205 return m_pToolSvc->retrieve( typeAndName(), IAlgTool::interfaceID(),
206 algTool,
207 ToolHandleInfo::parent(), ToolHandleInfo::createIf() );
208 }
ToolHandle::typeAndName
std::string typeAndName() const override
Definition: ToolHandle.h:199
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:214
ToolHandleInfo::parent
const IInterface * parent() const
Definition: ToolHandle.h:38
ServiceHandle::retrieve
StatusCode retrieve() const
Retrieve the Service.
Definition: ServiceHandle.h:56
ToolHandleInfo::createIf
bool createIf() const
Definition: ToolHandle.h:36
IInterface::interfaceID
static const InterfaceID & interfaceID()
Return an instance of InterfaceID identifying the interface.
Definition: IInterface.h:243
template<class T>

StatusCode ToolHandle< T >::initialize | ( | const std::string & | toolTypeAndName,
|  | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Definition at line 157 of file ToolHandle.h.

158 {
159
160 GaudiHandleBase::setTypeAndName(toolTypeAndName);
161 GaudiHandleBase::setComponentType(toolComponentType(parent));
162 GaudiHandleBase::setParentName(toolParentName(parent));
163
164 m_parent = parent;
165 m_createIf = createIf;
166
167 StatusCode sc = m_pToolSvc.initialize("ToolSvc", GaudiHandleBase::parentName());
168
169 return sc;
170 }
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:214
GaudiHandleBase::setTypeAndName
void setTypeAndName(std::string myTypeAndName)
The component "type/name" string.
Definition: GaudiHandle.cpp:9
GaudiHandleInfo::setComponentType
void setComponentType(const std::string &componentType)
The component type.
Definition: GaudiHandle.h:67
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:47
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:49
GaudiHandleInfo::setParentName
void setParentName(const std::string &parent)
The name of the parent.
Definition: GaudiHandle.h:72
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:43
merge_files.sc
int sc
Definition: merge_files.py:167
ServiceHandle::initialize
StatusCode initialize(const std::string &serviceName, const std::string &theParentName)
Definition: ServiceHandle.h:46
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
ToolHandleInfo::parent
const IInterface * parent() const
Definition: ToolHandle.h:38
ToolHandleInfo::createIf
bool createIf() const
Definition: ToolHandle.h:36
ToolHandleInfo::m_parent
const IInterface * m_parent
Definition: ToolHandle.h:54
ToolHandleInfo::m_createIf
bool m_createIf
Definition: ToolHandle.h:55
template<class T>

StatusCode ToolHandle< T >::release | ( |  | ) | const
| inline

Release the AlgTool.

Function must be repeated here to avoid hiding the function release( T*& )

Definition at line 180 of file ToolHandle.h.

180 { // not really const, because it updates m_pObject
181 return GaudiHandle<T>::release();
182 }
GaudiHandle::release
StatusCode release() const
Release the component.
Definition: GaudiHandle.h:215
template<class T>

StatusCode ToolHandle< T >::release | ( | T * | algTool | ) | const
| inline override virtual

Do the real release of the AlgTool.

Reimplemented from GaudiHandle< T >.

Definition at line 192 of file ToolHandle.h.

192 {
193 return m_pToolSvc->releaseTool( algTool );
194 }
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:214
template<class T>

StatusCode ToolHandle< T >::retrieve | ( |  | ) | const
| inline

Retrieve the AlgTool.

Release existing tool if needed. Function must be repeated here to avoid hiding the function retrieve( T*& )

Definition at line 174 of file ToolHandle.h.

174 { // not really const, because it updates m_pObject
175 return GaudiHandle<T>::retrieve();
176 }
GaudiHandle::retrieve
StatusCode retrieve() const
Retrieve the component.
Definition: GaudiHandle.h:205
template<class T>

StatusCode ToolHandle< T >::retrieve | ( | T *& | algTool | ) | const
| inline override virtual

Do the real retrieval of the AlgTool.

Implements GaudiHandle< T >.

Definition at line 185 of file ToolHandle.h.

185 {
186 IAlgTool* iface = nullptr;
187 algTool = i_retrieve(iface) ? dynamic_cast<T*>(iface) : nullptr;
188 return algTool ? StatusCode::SUCCESS : StatusCode::FAILURE;
189 }
ToolHandle::i_retrieve
StatusCode i_retrieve(IAlgTool *&algTool) const override
Definition: ToolHandle.h:204
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode::SUCCESS
Definition: StatusCode.h:30
IAlgTool
The interface implemented by the AlgTool base class.
Definition: IAlgTool.h:23
template<class T>

std::string ToolHandle< T >::typeAndName | ( |  | ) | const
| inline override virtual

Implements BaseToolHandle.

Definition at line 199 of file ToolHandle.h.

199 {
200 return GaudiHandleBase::typeAndName();
201 }
GaudiHandleBase::typeAndName
std::string typeAndName() const
The full type and name: "type/name".
Definition: GaudiHandle.h:120

## Friends And Related Function Documentation

template<class T>

friend class Algorithm
| friend

Definition at line 99 of file ToolHandle.h.

template<class T>

friend class AlgTool
| friend

Definition at line 100 of file ToolHandle.h.

template<class T>

friend class Service
| friend

Definition at line 101 of file ToolHandle.h.

## Member Data Documentation

template<class T>

ServiceHandle<IToolSvc> ToolHandle< T >::m_pToolSvc
| mutable private

Definition at line 214 of file ToolHandle.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/PropertyMgr.h
- GaudiKernel/GaudiKernel/ToolHandle.h